<?php


// don't load directly
if ( !function_exists( 'is_admin' ) ) {
	header( 'Status: 403 Forbidden' );
	header( 'HTTP/1.1 403 Forbidden' );
	exit();
}



if ( !class_exists( "Tocka_Walker_Nav_Menu_Edit" ) && class_exists( 'Walker_Nav_Menu_Edit' ) ):

class Tocka_Walker_Nav_Menu_Edit extends Walker_Nav_Menu_Edit {
	
	
	function start_el(&$output, $item, $depth, $args) {
		
		// append next menu element to $output
		parent::start_el($output, $item, $depth, $args);
		
		
		// now let's add a custom form field
		
		if ( ! class_exists( 'phpQuery') ) {
			// load phpQuery at the last moment, to minimise chance of conflicts (ok, it's probably a bit too defensive)
			require_once 'phpQuery-onefile.php';
		}
		
		$_doc = phpQuery::newDocumentHTML( $output );
		$_li = phpQuery::pq( 'li.menu-item:last' ); // ":last" is important, because $output will contain all the menu elements before current element
		
		// if the last <li>'s id attribute doesn't match $item->ID something is very wrong, don't do anything
		// just a safety, should never happen...
		$menu_item_id = str_replace( 'menu-item-', '', $_li->attr( 'id' ) );
		if( $menu_item_id != $item->ID ) {
			return;
		}
		
		// fetch previously saved meta for the post (menu_item is just a post type)
		$test_val = esc_attr( get_post_meta( $menu_item_id, 'tocka_menu_item_test_val', TRUE ) );
		
		// by means of phpQuery magic, inject a new input field
		$_li->find( '.link-to-original' )
			->after(  "<p><input type='text' value='$test_val' name='tocka_menu_item_test_val_$menu_item_id' /></p>" );
		
		// swap the $output
		$output = $_doc->html();
		
	}

}

endif;
